<?php
/*
class birthday extends phplistPlugin {
    public $name = "Birthday plugin";
    public $author = "Hernan Cisneros";
    public $coderoot = "plugins/birthday/";
    #define months' lenght (in days)
    public $table = "phplist_user_birthday";
    protected $allmonths = 
      array(
      "01" => "31",
      "02" => "28",
      "03" => "31",
      "04" => "30",
      "05" => "31",
      "06" => "30",
      "07" => "31",
      "08" => "31",
      "09" => "30",
      "10" => "31",
      "11" => "30",
      "12" => "31");
    public $errorcase;
    public $lang = array(); # language for this plugin
    protected $dbstruct = array( # order of tables is essential for smooth upgrade
      "user_birthday" => array (
        "userid" => array("integer not null primary key unique","USERID"),
        "year" => array("varchar(30) not null","Year"),
        "sentdate" => array("datetime not null","Last bd message"),
      ));
    public $messageid;
    protected $numdays;
    protected $onlycommandline;

//    public $message = '';
//    public $error = '';


//    var $name = "Birthday plugin";
//    var $author = "Hernan Cisneros";
//    var $coderoot = "plugins/birthday/";
//    #define months' lenght (in days)
//    var $table = "phplist_user_birthday";
//    var $allmonths = 
//      array(
//      "01" => "31",
//      "02" => "28",
//      "03" => "31",
//      "04" => "30",
//      "05" => "31",
//      "06" => "30",
//      "07" => "31",
//      "08" => "31",
//      "09" => "30",
//      "10" => "31",
//      "11" => "30",
//      "12" => "31");
//    var $errorcase;
//    var $lang = array(); # language for this plugin
//    var $dbstruct = array( # order of tables is essential for smooth upgrade
//      "user_birthday" => array (
//        "userid" => array("integer not null primary key unique","USERID"),
//        "year" => array("varchar(30) not null","Year"),
//        "sentdate" => array("datetime not null","Last bd message"),
//      ));
//    var $messageid;
//    var $numdays;
//    var $onlycommandline;

    function initialise() {
        echo __FUNCTION__;
        return;
    }

    function renderError() {
        echo __FUNCTION__;
        return;
    }

    function runChecks() {
        echo __FUNCTION__;
        return;
    }

    function runBirthdaySending() {
        echo __FUNCTION__;
        return;
    }

    function render() {
        echo __FUNCTION__;
        return;
    }

}
*/

class birthday extends phplistPlugin {

    public $name = "Birthday plugin";
    public $author = "Hernan Cisneros";
    public $coderoot = "plugins/birthday/";

    public $topMenuLinks = array(
        'main' => array('category' => 'campaigns'),
    );
    public $pageTitles = array(
        'main' => 'Birthday',
    );


    #define months' lenght (in days)
    public $table = "phplist_user_birthday";
    protected $allmonths = 
      array(
      "01" => "31",
      "02" => "28",
      "03" => "31",
      "04" => "30",
      "05" => "31",
      "06" => "30",
      "07" => "31",
      "08" => "31",
      "09" => "30",
      "10" => "31",
      "11" => "30",
      "12" => "31");
    public $errorcase;
    public $lang = array(); # language for this plugin
    protected $dbstruct = array( # order of tables is essential for smooth upgrade
      "user_birthday" => array (
        "userid" => array("integer not null primary key unique","USERID"),
        "year" => array("varchar(30) not null","Year"),
        "sentdate" => array("datetime not null","Last bd message"),
      ));
    public $messageid;
    protected $numdays;
    protected $onlycommandline;

    public $message = '';
    public $error = '';

    public function __construct()
    {
        parent::__construct();
        $this->coderoot = dirname(__FILE__) . '/birthday/';
    }

    public function setup() {
      global $I18N,$tables,$birthday_lang;

      foreach ($birthday_lang as $name => $text)
        $this->lang[$name] = $text;

      $query =  sprintf('SELECT value FROM `%s` WHERE item = "birthday_onlycommandline"',$tables["config"]);
      $result = Sql_Query($query);
      $auto_birthday = Sql_Fetch_Array($result);
      $this->onlycommandline = $auto_birthday[0];
      if (!Sql_Table_exists($this->table)) {
        if (!isset($_GET["init"])) {
          $this->message .= $I18N->get("strBirthdayExplain <a href=\"./?page=main&pi=birthday&init=yes\">Initialise the plugin</a>");
          $this->errorcase = 1;
        }
        elseif (isset($_GET["init"]) && $_GET["init"] == "yes") {
          sql_query("CREATE TABLE ".$this->table." (
    `userid` INT( 10 ) NOT NULL ,
    `year` VARCHAR( 30 ) NOT NULL ,
    `sentdate` datetime NOT NULL ,
    PRIMARY KEY ( `userid` )
    ) ");
          sql_query(sprintf("insert into %s (item, value, editable) values('birthday_message_id',0,1)",$tables["config"]));
          sql_query(sprintf("insert into %s (item, value, editable) values('birthday_onlycommandline',0,1)",$tables["config"]));
          sql_query(sprintf("insert into %s (item, value, editable) values('birthday_numdays',7,1)",$tables["config"]));
          if (!mysql_error()) print $I18N->get("strBirthdayReady");
          else print $I18N->get("strBirthdayInitError");
          return 1;
        }
      } else {
        $this->messageid = getConfig('birthday_message_id');
        $this->numdays = getConfig('birthday_numdays');
        $this->onlycommandline = getConfig('birthday_onlycommandline');
        return 1;
      }
      # phplist_config : birthday_message_id, birthday_onlycommandline
      # phplist_user_birthday : columns(userid,year,sentdate) something else..?
    }

    public function runChecks() {
      global $commandline, $I18N;

      if ($this->errorcase) {
        return 0;
      }

      if (!$commandline) {
        @flush();
        if ($this->onlycommandline) {
          $this->errorcase = 1;
          $this->error .= "<p>This page can only be called from the commandline</p>";
          logEvent("This page can only be called from the commandline");
          return 0;
        } else {
          return 1; # No commandline and no BIRTHDAY_ONLYCOMMANDLINE, so it will be run from frontend
        }
      } else {
        if (!$this->onlycommandline) {
          $this->errorcase = 1;
          #logEvent("Cron is running but Birthday is disabled");
          return 0;
        } else {
          return 1; # Commandline and BIRTHDAY_ONLYCOMMANDLINE on, so it will run from commandline
        }
      }

    }

    public function error() {

      global $commandline;

      if ($commandline && $this->errorcase) {
        ob_end_clean();
        $this->error .= $GLOBALS["I18N"]->get("Cron is running but Birthday is disabled");
    #    return 1;
      } elseif (!$commandline && $this->errorcase && $this->onlycommandline) {
          $this->error .= $GLOBALS["I18N"]->get("This page can only be called from the commandline");
    #  return 0;
      } else {
        return;
      }
    }

    # function errorcase() {

    # }

    public function evalDate($birthday, $today) {
      $months = $this->allmonths;

    # evaluate today var in relation to the birthday

      $year = substr($today, 0, 4);
      $month = substr($today, 5, 2);
      $day = substr($today, 8, 2);

      # do the same with the birthday date / mmm, I think year is obsolete, but doesn't hurt ^_^

      $birYear = substr($birthday, 0, 4);
      $birMonth = substr($birthday, 5, 2);
      $birDay = substr($birthday, 8, 2);
      $nextMonth = $month+1; # This is used in the next ELSEIF


      if ($birMonth == $month) { # evaluate now the day
      
      #  if ($months[$month] == 31) {
          $operation = $birDay-$day;
      #    if ($day < 25) {
        if (!is_numeric($birDay) || !is_numeric($birMonth)) { 
          return 0;
        }
        if (preg_match('/^[\-]+/',$operation)) {
          return 0; # birthday has passed, don't send it
        }
        else { # if operation is positive, which means birthday hasn't passed
          if ($operation < 8) {
            return 1; # great, first case of sending a birthday
          } # else wait until there are 7 days left to the birthday... nice ^_^
          else {
            return 0;
          }
      # NOTE: the other option could have been day == 24 and birDay == 2, in which case the value is negative, but the month is being evaluated in the first IF. So birthday being next month is evaluated in the next ELSEIF
        }
      #  }
      }
      
      elseif ($birMonth == $nextMonth) {
      
      
        if ($birDay > 6) { # This is default to not sending of birthday of course
          return 0;
        }
        else {
      
          $operation2 = $months[$month]-$day; # It's never negative
      
          $operation3 = $operation2+$birDay;
      
          if ($operation3 > 7) {
            return 0;
          }
          else {
            return 1;
          }
      
        }
      
      }
      
      return 0;

    }

    public function render() {
        require_once ($this->coderoot.'/main.tpl.php');
        return;
    }

    public function renderMessage($msg = '') {
        $this->message .= '<br />';
        $this->message .= $msg;
        $this->render();
    }

    public function renderError($error = '') {
        $this->error .= '<br />';
        $this->error .= $error;
        $this->render();
    }

    public function addMessage($e) {
        $this->message .= $e;
    }

    public function addError($e) {
        $this->error .= $e;
    }

    public function runBirthdaySending() {
        $query = sprintf("SELECT * FROM `%s` WHERE type = 'date' and LOWER(name) = 'birthday' limit 1", $GLOBALS["tables"]["attribute"]);
        $resBirth = Sql_Query($query);
        $birValue = Sql_Fetch_Array($resBirth);
        if (!Sql_Affected_Rows()) {
            $this->addError('Cant find attribute named "birthday" of type "date"');
            return;
        }
        $date = new Date();
        $today = $date->getDate();
        #print "<p>Today is $today.</p>";
        $year = substr($today, 0, 4);
        $month = substr($today, 5, 2);
        $day = substr($today, 8, 2);

        $query = sprintf("SELECT * FROM `%s` WHERE attributeid = %s",$GLOBALS["tables"]["user_attribute"],$birValue["id"]);
        $userAttTable = Sql_Query($query);

        $skippedCounter = 0;

        while ($values = Sql_Fetch_Array($userAttTable)) {

          if ($this->evalDate($values["value"] , $today)) {

            $query = sprintf("SELECT * FROM %s WHERE id = %s",$GLOBALS["tables"]["user"],$values["userid"]);
            $userUserTable = Sql_Query($query);
            $values2 = Sql_Fetch_Array($userUserTable);

            $query = sprintf("SELECT * FROM %s WHERE userid = %s AND year = %s",$this->table,$values["userid"], $year);
            $userBirTable = Sql_Query($query);
            $values3 = Sql_Fetch_Array($userBirTable);

            if (!Sql_Affected_Rows()) {
    #          $birMessage = getConfig("birthday_message_id");
              $query = sprintf("SELECT * FROM %s WHERE id = %s",$GLOBALS["tables"]["message"],$this->messageid);
              # mmm, next make it variable, so he can choose the id in the configure page/DONE
              $messageTable = Sql_Query($query);
              $message = Sql_Fetch_Array($messageTable);
              $success = sendEmail($this->messageid,$values2["email"],$values2["uniqid"],$values2["htmlemail"]);
            //output($GLOBALS['I18N']->get('It took').' some '.$GLOBALS['I18N']->get('seconds to send'));
              logEvent("Sent Birthday message ".$this->messageid." to ".$values2["email"]." ($success)");
              $this->addMessage(sprintf("<p>".$this->lang["strbdMsgSentTo"]."</p>",$this->messageid, $values2["email"], $success));
              $query = sprintf("INSERT INTO %s (userid,year) values (%s,%s)",$this->table, $values["userid"], $year);
              $insertQuery = Sql_Query($query);
              }
            else {
    #          $birMessage = getConfig("birthday_message_id");
              $query = sprintf("SELECT * FROM `phplist_message` WHERE id = %s",$this->messageid);
              # mmm, next make it variable, so he can choose the id in the configure page/DONE
              $messageTable = Sql_Query($query);
              $message = Sql_Fetch_Array($messageTable);
              $success = 0;
              logEvent("Birthday message ".$this->messageid." has already been sent to ".$values2["email"]." ($success)");
              $this->addMessage(sprintf("<p>".$this->lang["strbdMsgAlreadySentTo"]."</p>",$this->messageid, $values2["email"], $success));
            }

          } else {
            $skippedCounter++;
          }
        }

        logEvent("Birthday message ".$this->messageid." skipped for ".$skippedCounter." users.");
        if ($skippedCounter)
            $this->addMessage(sprintf("<p>".$this->lang["strbdMsgSkippedFor"]."</p>", $this->messageid, $skippedCounter));

    }

}
